/* =============================================================================
 * php_otpserver.h
 *                      - OTP server library PHP interface defination file.
 *  
 * OTP c100 | OTP c200
 * Copyright (C) 2007-2009 Feitian Technologies Co., Ltd
 * http://www.FTsafe.com
 *
 * Created on 2008-10-07, Last version: 2.0
 *
 * Version:2.0
 *  
 */


#ifndef PHP_OTPVERIFY_H
#define PHP_OTPVERIFY_H

/* PHP module name */
#define PHP_OTP_VERIFY_NAME		"ETOTP Verify"

/* version string */
#define PHP_OTP_VERIFY_VERSION "1.0.0-20091113"

extern zend_module_entry etotpverify_module_entry;
#define phpext_otpverify_ptr &etotpverify_module_entry

/* phpinfo () exports */
PHP_MINFO_FUNCTION(etotpverify);


/* =============================================================================
 * Function   : itsecurity_checkpwd 
 * Description: OTP ֤ӿ
 * Parameter  : 
 *		authkey			Կ
 *		authnum			֤
 *		authwnd		    ֤Χ, ͨ0-40
 *		otp				Ҫ֤Ķ̬
 *		otplen			Ҫ֤Ķ̬, ͨ6
 *		authresnum		֤ɹ֤
 *
 * return     : 0 - ɹ, ֵΪ.
 */
ZEND_FUNCTION(itsecurity_checkpwd);


/* =============================================================================
 * Function   : itsecurity_psw_syn 
 * Description: OTP ֤ͬӿ
 * Parameter  : 
 *		authkey			Կ
 *		authnum			ǰ֤
 *		otp1			Ҫͬĵһ̬
 *		otp1len			Ҫͬĵһ̬, ͨ6
 *		otp2			Ҫͬĵڶ̬
 *		otp2len			Ҫͬĵڶ̬, ͨ6
 *		syncwnd		    ֤ͬΧ, ͨ0-200
 *		authresnum		ͬɹ֤
 *				
 * return     : 0 - ɹ, ֵΪ.
 */
ZEND_FUNCTION(itsecurity_psw_syn);


/* =============================================================================
 * Function   : itsecurity_checkpwdc200
 * Description: OTP C200(TOTP) ֤ӿ
 * Parameter  : 
 *		authkey			Կ
 *      t               ǰʱUTC Epoch
 *      t0              ʼοʱUTC Epoch(ĬΪ0)
 *      x               TOTP仯(ĬΪ60)
 *      drift           Ưƴ
 *      authwnd		    ֤Χ, ͨ0-20
 *      lastsucc        ǰһ֤ɹUTC Epoch(ΪֹطŹ)
 *      otp				Ҫ֤Ķ̬
 *      otplen			Ҫ֤Ķ̬, ͨ6
 *      currsucc		֤ɹUTC Epoch
 *      currdft         ֤ɹĵǰƯƴ
 *
 * return     : 0 - ɹ, ֵΪ.
 */
ZEND_FUNCTION(itsecurity_checkpwdc200);


/* =============================================================================
 * Function   : itsecurity_psw_sync200
 * Description: OTP C200(TOTP) ͬӿ
 * Parameter  : 
 *		authkey			Կ
 *      t               ǰʱUTC Epoch
 *      t0              ʼοʱUTC Epoch(ĬΪ0)
 *      x               TOTP仯(ĬΪ60)
 *      drift           Ưƴ
 *      syncwnd         ͬΧ, ͨ0-20
 *      lastsucc        ǰһ֤ɹUTC Epoch(ΪֹطŹ)
 *      otp1            Ҫͬĵһ̬
 *      otp1len			Ҫͬĵһ̬, ͨ6
 *      otp2            Ҫͬĵڶ̬
 *      otp2len         Ҫͬĵڶ̬, ͨ6
 *      currsucc		֤ɹUTC Epoch
 *      currdft         ֤ɹĵǰƯƴ
 *
 * return     : 0 - ɹ, ֵΪ.
 */
ZEND_FUNCTION(itsecurity_psw_sync200);

/* =============================================================================
 * Function   : et_checkpwdz201
 * Description: OTP C201(TOTP) ֤ӿ
 * Parameter  : 
 *		authkey			Կ
 *      t               ǰʱUTC Epoch
 *      t0              ʼοʱUTC Epoch(ĬΪ0)
 *      x               TOTP仯(ĬΪ60)
 *      drift           Ưƴ
 *      authwnd		    ֤Χ, ͨ0-20
 *      lastsucc        ǰһ֤ɹUTC Epoch(ΪֹطŹ)
 *      otp				Ҫ֤Ķ̬
 *      otplen			Ҫ֤Ķ̬, ͨ6
 *      currsucc		֤ɹUTC Epoch
 *      currdft         ֤ɹĵǰƯƴ
 *
 * return     : 0 - ɹ, ֵΪ.
 */
ZEND_FUNCTION(et_checkpwdz201);


/* =============================================================================
 * Function   : et_syncz201
 * Description: OTP C201(TOTP) ͬӿ
 * Parameter  : 
 *		authkey			Կ
 *      t               ǰʱUTC Epoch
 *      t0              ʼοʱUTC Epoch(ĬΪ0)
 *      x               TOTP仯(ĬΪ60)
 *      drift           Ưƴ
 *      syncwnd         ͬΧ, ͨ0-20
 *      lastsucc        ǰһ֤ɹUTC Epoch(ΪֹطŹ)
 *      otp1            Ҫͬĵһ̬
 *      otp1len			Ҫͬĵһ̬, ͨ6
 *      otp2            Ҫͬĵڶ̬
 *      otp2len         Ҫͬĵڶ̬, ͨ6
 *      currsucc		֤ɹUTC Epoch
 *      currdft         ֤ɹĵǰƯƴ
 *
 * return     : 0 - ɹ, ֵΪ.
 */
ZEND_FUNCTION(et_syncz201);

#endif /* !PHP_OTPSERVER_H */

